import {FinancialStatus, FulfillmentStatus} from '../Interfaces/ShopifyTypes';
import {DiscountApplication} from './DiscountApplication';
import {DiscountCode} from './DiscountCode';
import {LineItem} from './LineItem';
import {LatLongAddress} from './Address';
import {Fulfillment} from './Fulfillment';
import {Customer} from './Customer';
import {CreateContextOrderTransactionFunction, GetContextOrderTransactionCountFunction, GetContextOrderTransactionFunction, GetContextOrderTransactionsFunction} from '../Interfaces/IOrderTransaction';
import {GetContextOrderRefundFunction, GetContextOrderRefundsFunction} from '../Interfaces/IOrderRefund';
import {ShippingLine} from './ShippingLine';
import {TaxLine} from './TaxLine';
import {Base} from './Base';

export interface Order extends Base {
    email: string;
    closed_at?: any;
    updated_at: string;
    number: number;
    note?: string;
    token: string;
    gateway?: any;
    test: boolean;
    total_price: string;
    subtotal_price: string;
    total_weight: number;
    total_tax: string;
    taxes_included: boolean;
    currency: string;
    financial_status: FinancialStatus;
    confirmed: boolean;
    total_discounts: string;
    total_line_items_price: string;
    cart_token?: any;
    buyer_accepts_marketing: boolean;
    name: string;
    referring_site?: any;
    landing_site?: any;
    cancelled_at: string;
    cancel_reason: 'customer' | 'fraud' | 'inventory' | 'declined' | 'other';
    total_price_usd?: any;
    checkout_token?: any;
    reference?: any;
    user_id?: any;
    location_id?: any;
    source_identifier?: any;
    source_url?: any;
    processed_at?: any;
    device_id?: any;
    phone?: any;
    customer_locale: string;
    app_id?: any;
    browser_ip?: any;
    landing_site_ref?: any;
    order_number: number;
    discount_applications: DiscountApplication[];
    discount_codes: DiscountCode[];
    note_attributes: any[];
    payment_gateway_names: string[];
    processing_method: 'checkout' | 'direct' | 'manual' | 'offsite' | 'express';
    checkout_id?: any;
    source_name: string;
    fulfillment_status: FulfillmentStatus;
    tax_lines: TaxLine[];
    tags: string;
    contact_email: string;
    order_status_url: string;
    line_items: LineItem[];
    shipping_lines: ShippingLine[];
    billing_address: LatLongAddress;
    shipping_address: LatLongAddress;
    fulfillments: Fulfillment[];
    refunds: any[];
    customer: Customer;
    getTransactions?: GetContextOrderTransactionsFunction;
    getTransaction?: GetContextOrderTransactionFunction;
    getTransactionCount?: GetContextOrderTransactionCountFunction;
    getRefunds?: GetContextOrderRefundsFunction;
    getRefund?: GetContextOrderRefundFunction;
    createTransaction?: CreateContextOrderTransactionFunction;
}
